#include "imgui/imgui.h"
#include "imgui/imgui_impl_opengl3.h"
#include "imgui/imgui_impl_sdl.h"
#include "imgui/imgui_stdlib.h"
#include <SDL2/SDL.h>
#include <SDL2/SDL_opengl.h>
#include <cstdio>
#include <cstring>
#include <iterator>
#include <stdio.h>

#include <algorithm>
#include <array>
#include <fstream>
#include <iostream>
#include <list>
#include <random>
#include <sstream>
#include <string>
#include <type_traits>
#include <vector>

float gnoise(float noise) {
  std::random_device rd{};
  std::mt19937 gen{rd()};
  std::normal_distribution<> d{0, noise};
  return d(gen);
}

float enoise(float noise) { return 0.0; }

int enoise() {}

std::string loadTextFromFile() {
  std::ifstream t("file.txt");
  std::stringstream buffer;
  buffer << t.rdbuf();
  return buffer.str();
}

void shiftArrayBack(float (&original)[50]) {
  int original_Size = sizeof(original) / sizeof(original[0]);

  for (int i = 0; i < original_Size; i++) {
    original[i] = original[i + 1];
  }
  if (original[48] > 10.0 || original[48] < -10.0) {
    original[48] = 0.0;
  }
  original[49] = original[48] + gnoise(1.0);
}

void displayGNoise() {
  ImGui::Text("Time: %0.1f", ImGui::GetTime());
  // ImGui::Text("Random: %0.1f", gnoise(20.0));
  static float refresh_time = 0.0;
  static float gnoise_arr[50] = {};
  static int refresh_rate = 1.0;
  ImGui::Text("Refresh Rate");
  ImGui::SliderInt("samples/sec", &refresh_rate, 0.0, 60.0, "%.3f", 0);

  float average = 0.0f;
  if (refresh_time == 0.0)
    refresh_time = ImGui::GetTime();

  while (refresh_time < ImGui::GetTime() && refresh_rate != 0) {
    /* int gnoiseSize = sizeof(gnoise_arr)/sizeof(gnoise_arr[0]);
    for (int i=0; i<gnoiseSize; i++)
    {
      gnoise_arr[i] = GenerateRandomTag();
    } */
    shiftArrayBack(gnoise_arr);
    // gnoise_arr[49] = gnoise(1.0);
    for (int n = 0; n < IM_ARRAYSIZE(gnoise_arr); n++) {
      average += gnoise_arr[n];
    }
    average /= (float)IM_ARRAYSIZE(gnoise_arr);
    refresh_time += 1.0 / (float)refresh_rate;
  }

  ImGui::PlotLines("Noise", gnoise_arr, IM_ARRAYSIZE(gnoise_arr));
  ImGui::PlotLines("", gnoise_arr, IM_ARRAYSIZE(gnoise_arr), 0, NULL, -10.0f,
                   10.0f, ImVec2(0.0f, 80.0f));
}

class wave {
public:
  wave();
  int id;
  std::string wave_name;
  int dim;
  std::vector<float> data;

private:
  int checksum;
};

wave::wave() {
  id = 0;
  wave_name = "";
  dim = 1;
  data = {};
}

class variable {
public:
  variable();
  int id;
  std::string variable_name;
  float value;
  enum type {};

private:
  int checksum;
};

variable::variable() {
  id = 0;
  variable_name = "";
  value = 0.0;
}

class dataBrowser {
public:
  dataBrowser();
  std::list<wave> waves;
  std::list<variable> variables;
  std::list<wave>::iterator wave_iter;
  std::list<wave>::iterator iter_variable;
  void KillData();
};

dataBrowser::dataBrowser() {
  waves = {};
  variables = {};
  wave_iter = {};
  iter_variable = {};
}

void dataBrowser::KillData() { return; }

class newWindow {
public:
  newWindow();
  void Render();
  void GenerateWindowTitle();
  int id;
  std::string message;
  bool isRunning;
  bool kill;
  char *window_title;

private:
};

newWindow::newWindow() {
  isRunning = false;
  kill = false;
  message = "empty";
  id = 0;
  window_title = 0;
}

void newWindow::Render() {
  if (isRunning == false) {
    return;
  }
  ImGui::Begin(window_title);
  ImGui::Text("%s", message.c_str());

  if (ImGui::Button("Ok.")) {
    std::cout << "button: isRunning false\n";
    isRunning = false;
  }
  ImGui::Checkbox("isRunning", &isRunning);
  // ImGui::SliderFloat("", &randomTag, -3.0, 10.0, "%.3f");
  ImGui::End();
}

void newWindow::GenerateWindowTitle() {

  std::string standardHeader = "Window ";
  std::string imguiSpecialWindowCode = "##";
  std::string idNumberString = std::to_string(id);

  std::string combo =
      standardHeader + idNumberString + imguiSpecialWindowCode + idNumberString;

  char *newWindowTitleChar = new char[combo.size() + 1];

  std::copy(combo.begin(), combo.end(), newWindowTitleChar);
  newWindowTitleChar[combo.size()] = '\0';

  window_title = newWindowTitleChar;

  std::cout << "generate window: isRunning true\n";

  isRunning = true;
}

void popWindowNewMessage(std::string message) {
  static int counter = 0;

  ImGui::Begin("Made it##");
  ImGui::Text("%s", message.c_str());
  ImGui::Text("%d", counter);
  ImGui::End();

  counter++;
}

void spawnNewWindowWithMessage(char *message, std::list<newWindow> *list) {
  std::string editableMessage(message);
  if (editableMessage.size() == 0) {
    return;
  }
  std::cout << "called new win message\n";
  std::cout << "start list size: " << list->size() << "\n";
  static int counter = 1;
  newWindow nWin;
  nWin.message = editableMessage;
  nWin.id = counter;
  nWin.GenerateWindowTitle();
  list->push_back(nWin);
  counter++;
  std::cout << "End Size: " << list->size() << "\n";
}

void spawnNewWindowMessage(std::string message, std::list<newWindow> *list) {
  std::string editableMessage = message;
  if (editableMessage.size() == 0) {
    return;
  }
  std::cout << "called new win message\n";
  std::cout << "start list size: " << list->size() << "\n";
  static int counter = 1;
  newWindow nWin;
  nWin.message = editableMessage;
  nWin.id = counter;
  nWin.GenerateWindowTitle();
  list->push_back(nWin);
  counter++;
  std::cout << "End Size: " << list->size() << "\n";
}

void FlagWindowForKillById(int id, std::list<newWindow> &list) {
  std::list<newWindow>::iterator i = list.begin();
  for (newWindow &nWin : list) {
    if (nWin.id == id) {
      nWin.kill = true;
      return;
    }
    i++;
  }
  std::cout << "> [ERROR] No Window Found"
            << "\n";
}

void ProcessKillFlags(std::list<newWindow> &list) {
  std::list<newWindow>::iterator i = list.begin();
  for (newWindow &nWin : list) {
    if (nWin.kill) {
      list.erase(i);
      return;
    }
    i++;
  }
}

void KillWave(int id, dataBrowser &dataBrowser) {

  std::list<wave>::iterator iter =
      std::remove_if(dataBrowser.waves.begin(), dataBrowser.waves.end(),
                     [id](wave n) { return n.id == id; });

  dataBrowser.waves.erase(iter, dataBrowser.waves.end());

  // ... this loop works without breaking.
  // ... use an internal iterator inside of the dataBrowser object
  // ... compare the current iterator with the ImGui widget identifier
  /*   for (auto it = dataBrowser.waves.begin(); it != dataBrowser.waves.end();)
    { if (it->id == id) { it = dataBrowser.waves.erase(it);
        dataBrowser.wave_iter = it;
      } else {
        ++it;
      }
    } */
}

// Make button to kill wave
void ImShowKillWaveButton(int id, dataBrowser &dataBrowser) {
  std::string button_message = "Kill";
  std::string id_fill = "" + std::to_string(id);
  std::string button_id = button_message + id_fill + std::to_string(id);
  if (ImGui::Button(button_id.c_str())) {
    KillWave(id, dataBrowser);
  }
}

// Make button to kill window
void FlagWindowForKillButton(int id, std::list<newWindow> &list) {
  std::string button_message = "Kill";
  std::string id_fill = "##" + std::to_string(id);
  std::string button_id = button_message + id_fill + std::to_string(id);
  if (ImGui::Button(button_id.c_str())) {
    FlagWindowForKillById(id, list);
  }
}

void imguiShowAllListMembers(std::list<newWindow> &list) {
  ImGui::Text("Currently Loaded Windows");
  ImGui::SameLine();
  ImGui::Text("%zu", list.size());
  for (newWindow &nWin : list) {
    FlagWindowForKillButton(nWin.id, list);
    ImGui::SameLine();
    std::string id_fill = "##" + std::to_string(nWin.id);
    ImGui::Checkbox(id_fill.c_str(), &nWin.kill);
    ImGui::SameLine();
    ImGui::Text("%s", nWin.window_title);
    ImGui::SameLine();
    ImGui::Text(": %s", nWin.message.c_str());
  }
}

// Main code
int main(int, char **) {
  if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER | SDL_INIT_GAMECONTROLLER) !=
      0) {
    printf("Error: %s\n", SDL_GetError());
    return -1;
  }

  // GL Versioning
  const char *glsl_version = "#version 130";
  SDL_GL_SetAttribute(SDL_GL_CONTEXT_FLAGS, 0);
  SDL_GL_SetAttribute(SDL_GL_CONTEXT_PROFILE_MASK, SDL_GL_CONTEXT_PROFILE_CORE);
  SDL_GL_SetAttribute(SDL_GL_CONTEXT_MAJOR_VERSION, 3);
  SDL_GL_SetAttribute(SDL_GL_CONTEXT_MINOR_VERSION, 0);

  // Create window with graphics context
  SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
  SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 24);
  SDL_GL_SetAttribute(SDL_GL_STENCIL_SIZE, 8);

  SDL_WindowFlags window_flags =
      (SDL_WindowFlags)(SDL_WINDOW_OPENGL | SDL_WINDOW_RESIZABLE |
                        SDL_WINDOW_ALLOW_HIGHDPI);
  SDL_Window *window = SDL_CreateWindow(
      "Dear ImGui SDL2+OpenGL3 example", SDL_WINDOWPOS_CENTERED,
      SDL_WINDOWPOS_CENTERED, 1280, 1200, window_flags);
  SDL_GLContext gl_context = SDL_GL_CreateContext(window);
  SDL_GL_MakeCurrent(window, gl_context);

  // Setup Dear ImGui context
  IMGUI_CHECKVERSION();
  ImGui::CreateContext();
  ImGuiIO &io = ImGui::GetIO();
  (void)io;

  // Setup Dear ImGui style
  // ImGui::StyleColorsDark();
  ImGui::StyleColorsClassic();

  // Setup Platform/Renderer backends
  ImGui_ImplSDL2_InitForOpenGL(window, gl_context);
  ImGui_ImplOpenGL3_Init(glsl_version);

  // Set Scale Factor for visibility
  constexpr auto scale_factor = 1.5;
  ImGui::GetStyle().ScaleAllSizes(scale_factor);
  ImGui::GetIO().FontGlobalScale = scale_factor;

  // ... used in GL CLEAR COLOR?
  ImVec4 clear_color = ImVec4(0.45f, 0.55f, 0.60f, 1.00f);

  std::string textMsg = "hallo";
  std::list<newWindow> winList;

  dataBrowser dataBrowser;

  wave wave1;
  wave1.wave_name = "longwave";
  wave1.id = 0;
  wave1.dim = 1;
  wave1.data = {0.03, 0.01, 1.00, 1.003, 0.9};
  wave wave2;
  wave2.wave_name = "second longwave";
  wave2.id = 1;
  wave2.dim = 1;
  wave2.data = {0.03, 0.01, 1.00, 1.003, 0.9};
  wave wave3;
  wave3.wave_name = "second longwave";
  wave3.id = 3;
  wave3.dim = 1;
  wave3.data = {0.03, 0.01, 1.00, 1.003, 0.9};
  wave wave4;
  wave4.wave_name = "second longwave";
  wave4.id = 4;
  wave4.dim = 1;
  wave4.data = {0.03, 0.01, 1.00, 1.003, 0.9};

  dataBrowser.waves.push_back(wave1);
  dataBrowser.waves.push_back(wave2);
  dataBrowser.waves.push_back(wave3);
  dataBrowser.waves.push_back(wave4);

  // Main loop
  std::cout << "\n> Started ...\n";
  bool programIsTerminated = false;
  while (!programIsTerminated) {
    SDL_Event event;
    while (SDL_PollEvent(&event)) {
      ImGui_ImplSDL2_ProcessEvent(&event);
      if (event.type == SDL_QUIT)
        programIsTerminated = true;
      if (event.type == SDL_WINDOWEVENT &&
          event.window.event == SDL_WINDOWEVENT_CLOSE &&
          event.window.windowID == SDL_GetWindowID(window))
        programIsTerminated = true;
    }
    // Start the Dear ImGui frame
    ImGui_ImplOpenGL3_NewFrame();
    ImGui_ImplSDL2_NewFrame();
    ImGui::NewFrame();

    if (1) {
      ImGui::ShowDemoWindow();
    }
    // ... Bil Window Be Low
    {
      ImGui::Begin("Data Browser");
      ImGui::Text("Formatting errors: %s, %a", textMsg.c_str(),
                  textMsg.c_str());

      static char new_window_message_buffer[32] = "";
      static const ImGuiInputTextFlags flags =
          ImGuiInputTextFlags_EnterReturnsTrue;
      if (ImGui::Button("Spawn Window")) {
        spawnNewWindowWithMessage(new_window_message_buffer, &winList);
        strcpy(new_window_message_buffer, "");
      }
      ImGui::SameLine();
      if (ImGui::InputTextWithHint(
              "", "enter window name...", new_window_message_buffer,
              IM_ARRAYSIZE(new_window_message_buffer), flags)) {
        spawnNewWindowWithMessage(new_window_message_buffer, &winList);
        strcpy(new_window_message_buffer, "");
      }

      if (ImGui::Button("Load Text From file")) {
        spawnNewWindowMessage(loadTextFromFile(), &winList);
      }
      ImGui::Separator();
      static int killWindowIndex = 0;
      ImGui::InputInt("Window Id", &killWindowIndex);
      ImGui::SameLine();
      if (ImGui::Button("Kill Window")) {
        FlagWindowForKillById(killWindowIndex, winList);
      }

      ImGui::SameLine();
      ImGui::Text("%zu Windows Exist", winList.size());

      if (ImGui::TreeNode("Loaded Windows")) {
        imguiShowAllListMembers(winList);
        ImGui::TreePop();
      }

      displayGNoise();

      for (dataBrowser.wave_iter = dataBrowser.waves.begin();
           dataBrowser.wave_iter != dataBrowser.waves.end();
           ++dataBrowser.wave_iter) {
        ImShowKillWaveButton(dataBrowser.wave_iter->id, dataBrowser);
        ImGui::SameLine();
        ImGui::Text("wave: %s", dataBrowser.wave_iter->wave_name.c_str());
        ImGui::SameLine();
        float *a = &dataBrowser.wave_iter->data[0];
        ImGui::PlotLines("", a, 10);
      }

      ImGui::End();
    }

    // ... Render all tracked window objects
    // ... things I've learned
    // ... references are a real thing to use and goddamn are they important
    // ... this loop is meant to take all the newWindow objects in
    // ... winList and run their render function
    for (newWindow &nnWin : winList) {
      nnWin.Render();
    }
    ProcessKillFlags(winList);

    // Rendering
    ImGui::Render();
    glViewport(0, 0, (int)io.DisplaySize.x, (int)io.DisplaySize.y);
    glClearColor(clear_color.x * clear_color.w, clear_color.y * clear_color.w,
                 clear_color.z * clear_color.w, clear_color.w);
    glClear(GL_COLOR_BUFFER_BIT);
    ImGui_ImplOpenGL3_RenderDrawData(ImGui::GetDrawData());
    SDL_GL_SwapWindow(window);
  }

  // Cleanup
  ImGui_ImplOpenGL3_Shutdown();
  ImGui_ImplSDL2_Shutdown();
  ImGui::DestroyContext();

  SDL_GL_DeleteContext(gl_context);
  SDL_DestroyWindow(window);
  SDL_Quit();

  return 0;
}
